#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#include "mpapp.h"

void createMenu();

int main(int argc, char **argv, char** env)
{
	id pool;
	NSApplication *theApp;

	pool = [NSAutoreleasePool new];
	
#if LIB_FOUNDATION_LIBRARY
  	[NSProcessInfo initializeWithArguments:argv count:argc environment:env];
#endif
#ifndef NX_CURRENT_COMPILER_RELEASE
  	initialize_gnustep_backend();
#endif
	
	theApp = [NSApplication sharedApplication];
	[theApp setDelegate: [MPApp sharedmpapp]];  

	createMenu();

	[theApp run];
	[pool release];
	
	return 0;
}

void createMenu()
{
	NSMenu* menu;
	NSMenu* info;
	NSMenu *file;
	NSMenu *edit;
	NSMenu *lists;
	NSMenu *view;
	NSMenu* util;
	NSMenu* services;

	SEL action = @selector(method:);

	menu = [[NSMenu alloc] initWithTitle:@"MPlay"];
	[menu addItemWithTitle:@"Info" action:action keyEquivalent:@""];
	[menu addItemWithTitle:@"File" action:action keyEquivalent:@""];
	[menu addItemWithTitle:@"Edit" action:action keyEquivalent:@""];
	[menu addItemWithTitle:@"Lists" action:action keyEquivalent:@""];
	[menu addItemWithTitle:@"View" action:action keyEquivalent:@""];
	[menu addItemWithTitle:@"Utilities" action:action keyEquivalent:@""];
	[menu addItemWithTitle:@"Services" action:action keyEquivalent:@""];
	[menu addItemWithTitle:@"Quit" action:@selector(terminate:) keyEquivalent:@"q"];

	info = [NSMenu new];
	[menu setSubmenu:info forItem:[menu itemWithTitle:@"Info"]];
	[info addItemWithTitle:@"Info Panel..." action:action keyEquivalent:@""];
	[info addItemWithTitle:@"Preferences..." action:action keyEquivalent:@""];
	[info addItemWithTitle:@"Help" action:action keyEquivalent:@"?"];

	file = [NSMenu new];
	[file addItemWithTitle:@"Play Song..." action:@selector(playSong:) keyEquivalent:@"p"];
	[menu setSubmenu:file forItem:[menu itemWithTitle:@"File"]];

	edit = [NSMenu new];
	[edit addItemWithTitle:@"Cut" action:action keyEquivalent:@"x"];
	[edit addItemWithTitle:@"Copy" action:action keyEquivalent:@"c"];
	[edit addItemWithTitle:@"Paste" action:action keyEquivalent:@"v"];
	[menu setSubmenu:edit forItem:[menu itemWithTitle:@"Edit"]];

	lists  = [NSMenu new];
	[lists addItemWithTitle:@"New Songs List" action:@selector(newSongList:) keyEquivalent:@"n"];
	[lists addItemWithTitle:@"Remove Song List" action:@selector(removeSongList:) keyEquivalent:@"d"];
	[lists addItemWithTitle:@"Open Songs Window" action:@selector(openSongsWin:) keyEquivalent:@"o"];
	[menu setSubmenu:lists forItem:[menu itemWithTitle:@"Lists"]];
	
	view = [NSMenu new];
	[view addItemWithTitle:@"Show Lists Win" action:@selector(showListsWin:) keyEquivalent:@""];
	[view addItemWithTitle:@"Hide Lists Win" action:@selector(hideListsWin:) keyEquivalent:@""];
	[menu setSubmenu:view forItem:[menu itemWithTitle:@"View"]];

	util = [NSMenu new];
	[util addItemWithTitle:@"Inspector" action:action keyEquivalent:@""];
	[util addItemWithTitle:@"Palettes" action:action  keyEquivalent:@""];
	[util addItemWithTitle:@"Load Palette" action:action keyEquivalent:@""];
	[menu setSubmenu:util forItem:[menu itemWithTitle:@"Utilities"]];

	services = [NSMenu new];
	[menu setSubmenu:services forItem:[menu itemWithTitle:@"Services"]];

	[[NSApplication sharedApplication] setMainMenu:menu];		
	[[NSApplication sharedApplication] setServicesMenu: services];
	[menu update];
	[menu display];
}
