#ifndef MPAPP_H
#define MPAPP_H

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#include "mpcontrols.h"
#include "mpdisplay.h"
#include "mpplayer.h"
#include "listswin.h"

#include <unistd.h>
#include <signal.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <sys/wait.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <limits.h>
#include <sys/uio.h>

#include <X11/X.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>

@interface MPApp : NSObject
{
  	NSProcessInfo *pInfo;
  	NSDictionary *env;
	NSUserDefaults *defaults;	
	NSFileManager *fm;

	NSWindow *win;
	MPPlayer *player;
	
	MPPlayListsWin *listsWin;
	NSMutableDictionary *playListsDict;
	NSArray *currSongList;
	int listpos;
	NSString *currSongPath;
	
	int sendfd[2], receivefd[2];
	NSFileHandle *sendfh, *receivefh;
	BOOL listplaing;
}

+ (MPApp *)sharedmpapp;
- (void)applicationDidFinishLaunching:(NSNotification *)aNotification;
- (BOOL)applicationShouldTerminate:(NSApplication *)app;

- (void)method:menuCell;
- (void)saveChangesToPlayListsDict:(id)sender;

- (void)setNewSongToPlay:(NSString *)songPath;
- (void)setNewListToPlay:(NSArray *)listToPlay;
- (NSString *)currSongPath;
- (void)play;
- (void)stop;
- (void)nextSong;
- (void)previousSong;

- (NSString *)fullPathForApplication:(NSString *)appName;

@end

@interface MPApp (MenuOperations)

- (void)playSong:(id)sender;
- (void)newSongList:(id)sender;
- (void)openSongsWin:(id)sender;
- (void)removeSongList:(id)sender;
- (void)showListsWin:(id)sender;
- (void)hideListsWin:(id)sender;

@end

#endif // MPAPP_H

