#include "mpcontrols.h"
#include "mpapp.h"
#include "mpplayer.h"

extern BOOL isplaing;

@implementation MPControls

- (id)initWithFrame:(NSRect)frameRect
{
	NSRect prevRect = {{2, 8}, {26, 26}};
	NSRect revRect = {{28, 8}, {26, 26}};
	NSRect playstopRect = {{54, 8}, {26, 26}};
	NSRect ffRect = {{80, 8}, {26, 26}};
	NSRect nextRect = {{106, 8}, {26, 26}};
	NSRect posSlideRect = {{141, 14}, {68, 14}};
	NSString *iconpath;
	NSImage *icn;
	
	self = [super initWithFrame:frameRect];
  	if(self) {

	  	prevButt = [[[NSButton alloc] initWithFrame: prevRect] autorelease];
	  	[prevButt setButtonType: NSMomentaryLight];
		iconpath = [[[NSBundle mainBundle] bundlePath] stringByAppendingString:@"/Resources/tostart.tiff"];
		icn = [[NSImage alloc] initWithContentsOfFile: iconpath];
		[prevButt setImage: icn];
		[icn release];
		[prevButt setImagePosition: NSImageOnly];
	  	[prevButt setTarget:self];
	  	[prevButt setAction:@selector(prevPressed:)];
		[self addSubview: prevButt]; 

	  	revButt = [[[NSButton alloc] initWithFrame: revRect] autorelease];
	  	[revButt setButtonType: NSMomentaryLight];
		iconpath = [[[NSBundle mainBundle] bundlePath] stringByAppendingString:@"/Resources/rwd.tiff"];
		icn = [[NSImage alloc] initWithContentsOfFile: iconpath];
		[revButt setImage: icn];
		[icn release];
		[revButt setImagePosition: NSImageOnly];
		[revButt setTarget:self];
		[revButt setAction:@selector(revPressed:)];
		[self addSubview: revButt]; 

	  	playstopButt = [[[NSButton alloc] initWithFrame: playstopRect] autorelease];
	  	[playstopButt setButtonType: NSMomentaryLight];
		iconpath = [[[NSBundle mainBundle] bundlePath] stringByAppendingString:@"/Resources/play.tiff"];
		icn = [[NSImage alloc] initWithContentsOfFile: iconpath];
		[playstopButt setImage: icn];
		[icn release];
		[playstopButt setImagePosition: NSImageOnly];
	  	[playstopButt setTarget:self];
	  	[playstopButt setAction:@selector(playStopPressed:)];
		[self addSubview: playstopButt]; 

	  	ffButt = [[[NSButton alloc] initWithFrame: ffRect] autorelease];
	  	[ffButt setButtonType: NSMomentaryLight];
		iconpath = [[[NSBundle mainBundle] bundlePath] stringByAppendingString:@"/Resources/ffwd.tiff"];
		icn = [[NSImage alloc] initWithContentsOfFile: iconpath];
		[ffButt setImage: icn];
		[icn release];
		[ffButt setImagePosition: NSImageOnly];
		[ffButt setTarget:self];
		[ffButt setAction:@selector(ffPressed:)];
		[self addSubview: ffButt]; 

	  	nextButt = [[[NSButton alloc] initWithFrame: nextRect] autorelease];
	  	[nextButt setButtonType: NSMomentaryLight];
		iconpath = [[[NSBundle mainBundle] bundlePath] stringByAppendingString:@"/Resources/toend.tiff"];
		icn = [[NSImage alloc] initWithContentsOfFile: iconpath];
		[nextButt setImage: icn];
		[icn release];
		[nextButt setImagePosition: NSImageOnly];
	  	[nextButt setTarget:self];
	  	[nextButt setAction:@selector(nextPressed:)];
		[self addSubview: nextButt]; 

  		posSlide = [[NSSlider alloc] initWithFrame:posSlideRect];
  //		[posSlide setMinValue:100];
  //		[posSlide setMaxValue:1000];
  //		[posSlide setContinuous:NO];
  	//	[posSlide setTarget:target];
  	//	[posSlide setAction:@selector(action:)];
  		[self addSubview:posSlide];

	}
  	return self;	
}

- (void) dealloc
{
  	[super dealloc];
}

- (void)playStopPressed:(id)butt
{
	NSString *iconpath;
	NSImage *icn;

	if(!isplaing) {	
		iconpath = [[[NSBundle mainBundle] bundlePath] stringByAppendingString:@"/Resources/stop.tiff"];
		icn = [[NSImage alloc] initWithContentsOfFile: iconpath];
		[playstopButt setImage: icn];
		[icn release];
		[playstopButt setImagePosition: NSImageOnly];
		[playstopButt setNeedsDisplay:YES];
		[[MPApp sharedmpapp] play];
	} else {
		iconpath = [[[NSBundle mainBundle] bundlePath] stringByAppendingString:@"/Resources/play.tiff"];
		icn = [[NSImage alloc] initWithContentsOfFile: iconpath];
		[playstopButt setImage: icn];
		[icn release];
		[playstopButt setImagePosition: NSImageOnly];
		[playstopButt setNeedsDisplay:YES];
		[[MPApp sharedmpapp] stop];
	}
}

- (void)prevPressed:(id)butt
{
	[[MPApp sharedmpapp] previousSong];
}

- (void)revPressed:(id)butt
{
	[[MPPlayer player] rewind];
}

- (void)ffPressed:(id)butt
{
	[[MPPlayer player] forward];
}

- (void)nextPressed:(id)butt
{
	[[MPApp sharedmpapp] nextSong];
}

- (void)resetButtons
{
	NSString *iconpath;
	NSImage *icn;

	isplaing = NO;

	iconpath = [[[NSBundle mainBundle] bundlePath] stringByAppendingString:@"/Resources/play.tiff"];
	icn = [[NSImage alloc] initWithContentsOfFile: iconpath];
	[playstopButt setImage: icn];
	[icn release];
	[playstopButt setImagePosition: NSImageOnly];
	[playstopButt setNeedsDisplay:YES];
}

- (void)setPlayStopButtonPos:(BOOL)isOn
{
	NSString *iconpath;
	NSImage *icn;

	if(!isOn) {	
		iconpath = [[[NSBundle mainBundle] bundlePath] stringByAppendingString:@"/Resources/stop.tiff"];
		icn = [[NSImage alloc] initWithContentsOfFile: iconpath];
		[playstopButt setImage: icn];
		[icn release];
		[playstopButt setImagePosition: NSImageOnly];
		[playstopButt setNeedsDisplay:YES];
	} else {
		iconpath = [[[NSBundle mainBundle] bundlePath] stringByAppendingString:@"/Resources/play.tiff"];
		icn = [[NSImage alloc] initWithContentsOfFile: iconpath];
		[playstopButt setImage: icn];
		[icn release];
		[playstopButt setImagePosition: NSImageOnly];
		[playstopButt setNeedsDisplay:YES];
	}
}

- (void)drawRect:(NSRect)rect
{
  	[[NSColor whiteColor] set];
  	PSmoveto(0, 36);
 	PSlineto(218, 36);
	PSstroke();
  	[[NSColor whiteColor] set];
  	PSmoveto(0, 7);
 	PSlineto(218, 7);
	PSstroke();

  	[[NSColor blackColor] set];
  	PSmoveto(139, 29);
 	PSlineto(209, 29);
	PSstroke();
  	[[NSColor whiteColor] set];
  	PSmoveto(138, 13);
 	PSlineto(209, 13);
	PSstroke();
  	[[NSColor blackColor] set];
  	PSmoveto(139, 29);
 	PSlineto(139, 14);
	PSstroke();
  	[[NSColor whiteColor] set];
  	PSmoveto(210, 27);
 	PSlineto(210, 14);
	PSstroke();
}

@end
