#ifndef MPDISPLAY_H
#define MPDISPLAY_H

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>
#include "controldata.h"

@interface MPDisplay : NSView
{
	NSTextField *trackLabel, *timeLabel, *frameLabel;
	NSTextField *trackField, *timeField, *framefield;
	NSTextField *songField;
	int currFrame, minutes, seconds;
	NSTimer *ttimer;
	NSWindow *myWin;
}

- (id)initWithFrame:(NSRect)frameRect ofWindow:(NSWindow *)win;

- (void)clearDisplay;
- (void)updateAudioInfo:(AudioInfo)ai;

- (void)setTrackField:(int)track;
- (void)setTimeField:(NSString *)timeStr;
- (void)setFrameField:(int)frameNum;
- (void)setSongField:(NSString *)songName;
- (void)timestep:(NSTimer *)t;

@end

#endif // MPDISPLAY_H
