#ifndef MPPLAYER_H
#define MPPLAYER_H

#import <Foundation/Foundation.h>
#include "controldata.h"

enum 
{
	forwardState = 1,
   forwardStep = 2,
   rewindState = 4,
   rewindStep = 8
};

@interface MPPlayer : NSObject
{
   BOOL dontFork;
   BOOL isForwarding;
   BOOL isRewinding;	
	int forwrewCount;
   int length;
   int send[2];
   int receive[2];
   int fork_pid;
	NSFileHandle *readSocketHandle;
}

+ (MPPlayer *)player;
- (void)initialize;
- (void)play:(NSString *)songPath;
- (void)stop;
- (void)forward;
- (void)forwardStep;
- (void)forwardEnd;
- (void)rewind;
- (void)rewindStep;
- (void)rewindEnd;
- (void)next;
- (BOOL)isPlaying;
- (void)songKilled:(NSNotification *)aNotification;
- (void)forkIt;
- (int)fork_pid;
- (void)setdontFork:(BOOL)boolval;
- (void)childDied:(BOOL)dontNotify;
- (void)send_msg:(PControlMsg)msg;
- (void)get_msg:(PControlMsg)msg;
- (void)parse_msg:(PControlMsg)msg;
- (void)pendingmsg:(NSNotification *)notification;
- (BOOL)sendQuery:(PControlMsg)msg;

@end

#endif // MPPLAYER_H
