#ifndef SONGSWIN_H
#define SONGSWIN_H

#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

@class MPPlaySongsWin;
@class MPPlayListsWin;

@interface ButtonsFrame : NSView
{
	MPPlaySongsWin *myWin;
	NSButton *addSongButt, *remSongButt, *playSongButt, *playListButt;
}

- (id)initInWindow:(MPPlaySongsWin *)win rect:(NSRect)rect;

@end

@interface MPPlaySongsMatrix : NSMatrix
{
	MPPlaySongsWin *myWin;
	BOOL isDragTarget;
}

- (id)initWithFrame:(NSRect)frameRect
	       		mode:(int)aMode
	  		 prototype:(NSCell *)aCell
       numberOfRows:(int)rowsHigh
    numberOfColumns:(int)colsWide
	 		  inWindow:(MPPlaySongsWin *)win;

- (void)fileSystemDidChange:(NSNotification *)aNotification;

@end

@interface MPPlaySongsMatrix (DraggingDestination)

- (unsigned int)draggingEntered:(id <NSDraggingInfo>)sender;
- (unsigned int)draggingUpdated:(id <NSDraggingInfo>)sender;
- (void)draggingExited:(id <NSDraggingInfo>)sender;
- (BOOL)prepareForDragOperation:(id <NSDraggingInfo>)sender;
- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender;
- (void)concludeDragOperation:(id <NSDraggingInfo>)sender;

@end

@interface MPPlaySongsWin : NSWindow
{
	NSString *myTitle;
	MPPlayListsWin *myListsWin;
	NSMutableArray *songsArr;
	NSString *currSongPath;
	ButtonsFrame *buttsFrame;
	NSView *myView;
  	NSScrollView *songsScroll;
  	MPPlaySongsMatrix *songsMatrix;	
  	NSButtonCell *buttonCell;
}

- (id)initWithSongs:(NSArray *)songs 
				  title:(NSString *)atitle 
			  listsWin:(MPPlayListsWin *)awin;
- (NSString *)getTitle;
- (NSArray *)songsArr;
- (void)handleSongsMatrixSelect:(id)sender;
- (void)addSong:(id)sender;
- (void)addSongFromDnD:(NSString *)songPath;
- (void)removeSong:(id)sender;
- (void)playSong:(id)sender;
- (void)playList:(id)sender;
- (void)runAlert:(NSString *)error;

@end

#endif // SONGSWIN_H
